<?php
/**
 * fmalertcookies.php
 *
 * php version 5
 *
 * @category  Joomla
 * @package   Joomla
 * @author    Folcomedia <contact@folcomedia.fr>
 * @copyright 2014 Folcomedia
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link      http://www.folcomedia.fr
 */

defined('_JEXEC') or die('Restricted access');

/**
 * Plugin Système Folcomedia Alert Cookies
 *
 * @category Joomla
 * @package  Joomla
 * @author   Folcomedia <contact@folcomedia.fr>
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link     http://www.folcomedia.fr
 */
class plgSystemFmAlertCookies extends JPlugin
{

	function onAfterInitialise(){

		$app      = JFactory::getApplication();

		if ($app->isSite()) {
			//insert les scripts nécessaire au bon fonctionnement du plugin
			$document = JFactory::getDocument();

			//Gestion des scripts suivant la version de Joomla utilisée.
	        if (JVERSION < 3) {
				if ($position = $this->params->get('ajouter_jquery')) {
					$document->addScript(JURI::root().'plugins/system/fmalertcookies/assets/js/jquery-1.11.1.min.js');
				}
	        } else {
				JHtml::_('jquery.framework');
			}

			if(!file_exists(dirname(__FILE__).'/assets/css/custom.css')){
				fopen(dirname(__FILE__).'/assets/css/custom.css',"w");
			}

			$document->addScript(JURI::root().'plugins/system/fmalertcookies/assets/js/bootstrap'.$this->params->get('utiliser_bootstrap').'.min.js');
			$document->addStyleSheet(JURI::root().'plugins/system/fmalertcookies/assets/css/bootstrap.min.css');
			$document->addStyleSheet(JURI::root().'plugins/system/fmalertcookies/assets/css/custom.css');

			if($this->params->get('type_affichage') == 0) {
				$document->addScript(JURI::root().'plugins/system/fmalertcookies/assets/js/jquery.magnific-popup.min.js');
				$document->addStyleSheet(JURI::root().'plugins/system/fmalertcookies/assets/css/magnific-popup.css');				
			}
		}
    }

	public function onContentPrepareForm($form, $data)
	{
		// Check we have a form
		if (!($form instanceof JForm))
		{
			$this->_subject->setError('JERROR_NOT_A_FORM');
			return false;
		}

		// Check we are manipulating a valid form.
		$app = JFactory::getApplication();
		
		if ($form->getName() != 'com_plugins.plugin' 
			|| isset($data->name) && $data->name != 'PLG_SYSTEM_FMALERTCOOKIES') {
			return true;
		}

		// Get site languages
		$languages = JLanguageHelper::getLanguages();

		// Inject fields into the form
		foreach ($languages as $tag => $language) {
			if(strpos( $language->title_native, '(')) {	
				$langue_name = substr($language->title_native, 0 , strpos($language->title_native,'(')-1);
			} else {
				$langue_name = $language->title_native;
			}	
			$language->lang_code = str_replace('-', '_', $language->lang_code);

				$form->load('					
				<form>
					<fields name="params">
						<fieldset name="'.$langue_name.'" label="'.JTEXT::_('PLG_SYSTEM_FMALERTCOOKIES_SAISIE_LANGUE').' '.$langue_name.'">
						   <field name="texte_alert_cookies_'.$language->lang_code.'" type="editor" height="250"
			                    description="PLG_SYSTEM_FMALERTCOOKIES_TEXTE_DESC"
			                    label="PLG_SYSTEM_FMALERTCOOKIES_TEXTE_LABEL" filter="safehtml"
			                /> 	
			                <field name="texte_readmore_'.$language->lang_code.'" type="text"
			                    description="PLG_SYSTEM_FMALERTCOOKIES_TEXTE_READMORE_DESC"               
			                    label="PLG_SYSTEM_FMALERTCOOKIES_TEXTE_READMORE_LABEL"
			                />	
			               <field name="link_readmore_menu_'.$language->lang_code.'" type="menuitem"
			                    description="PLG_SYSTEM_FMALERTCOOKIES_LINK_READMORE_MENU_DESC"
			                    label="PLG_SYSTEM_FMALERTCOOKIES_LINK_READMORE_MENU_LABEL"
			                />
			               <field name="ancre_link_readmore_menu_'.$language->lang_code.'" type="text"
			                    description="PLG_SYSTEM_FMALERTCOOKIES_ANCRE_LINK_READMORE_MENU_DESC"
			                    label="PLG_SYSTEM_FMALERTCOOKIES_ANCRE_LINK_READMORE_MENU_LABEL"
			                />
						    <field name="texte_close_'.$language->lang_code.'" type="text"
			                    description="PLG_SYSTEM_FMALERTCOOKIES_TEXTE_CLOSE_DESC"
			                    label="PLG_SYSTEM_FMALERTCOOKIES_TEXTE_CLOSE_LABEL"
			                /> 							   
                
						</fieldset>				
					</fields>
				</form>
			');
		}
		return true;
	}

	function onAfterRender()
    {
		if (!isset($_COOKIE['fmalertcookies'])) {

			$app      = JFactory::getApplication();
			$mydefaultlanguage = $this->params->get('mylanguage');
						
			//Récupére la langue active
			$lang = JFactory::getLanguage();
			$langue_code_actif = $lang->get('tag');
			
			
			$langue_code_actif = str_replace("-","_", $langue_code_actif);
			$mydefaultlanguage = str_replace("-","_", $mydefaultlanguage);
			
			
			$link_readmore_menu = $this->params->get('link_readmore_menu_'.$langue_code_actif);
			if($link_readmore_menu == '') $link_readmore_menu = $this->params->get('link_readmore_menu_'.$mydefaultlanguage);	
			
			$affichage_msg_page_cookie = $this->params->get('affichage_msg_page_cookie');
			//Test si l'on se trouve bien sur le site et non en administration
	        if (!$app->isSite() || (strtolower($_SERVER['REQUEST_URI']) == strtolower(JRoute::_("index.php?Itemid=".$link_readmore_menu)) && !$affichage_msg_page_cookie)) {
	            return;
	        }

			// Récupération des paramêtres
	        $position = $this->params->get('position');
			$type_affichage = $this->params->get('type_affichage');
	        $taille_cadre = $this->params->get('taille_cadre');		
			if(!strpos($taille_cadre,"%")){
				$taille_cadre = str_replace('px', '', $taille_cadre).'px';
			}
			$texte = $this->params->get('texte_alert_cookies_'.$langue_code_actif);
			if($texte == '') $texte = $this->params->get('texte_alert_cookies_'.$mydefaultlanguage);				        
 			$texte_couleur = $this->params->get('couleur_texte');
			$fond_couleur = $this->params->get('couleur_fond');
			$position_fixe = $this->params->get('position_fixe');
			$marge_ext = $this->params->get('marge_ext');
			$marge_int = $this->params->get('marge_int');
			$position_contenu = $this->params->get('position_contenu');
			
			$position_fixe_cookie = "";
			if($position_fixe && $type_affichage == 1){
				$position_fixe_cookie.= "position:fixed;z-index:10000;left: 0;right: 0;";	
				if($position == 1) {
					$position_fixe_cookie.= "bottom: 0;";
				}
			}
			
			//Bordures
			$type_bordure = $this->params->get('type_bordure');
			$taille_bordure = $this->params->get('taille_bordure');
			$couleur_bordure = $this->params->get('couleur_bordure');
			
			//Params btn
			$first_btn = $this->params->get('first_btn');
			$position_btn = $this->params->get('position_btn');
			
			//Params btn more
			$texte_readmore = $this->params->get('texte_readmore_'.$langue_code_actif);
			if($texte_readmore == '') $texte_readmore = $this->params->get('texte_readmore_'.$mydefaultlanguage);	
			$btn_more = $this->params->get('btn_more');
			$position_btn_more = $this->params->get('position_btn_more');
			$taille_btn_more = $this->params->get('taille_btn_more');
			$couleur_btn_more = $this->params->get('couleur_btn_more');
			$couleur_texte_btn_more = $this->params->get('couleur_texte_btn_more');
			
			$ancre_link_readmore_menu= $this->params->get('ancre_link_readmore_menu_'.$langue_code_actif);
			if($ancre_link_readmore_menu == '') $ancre_link_readmore_menu = $this->params->get('ancre_link_readmore_menu_'.$mydefaultlanguage);
			$ancre_link_readmore_menu = str_replace('#', '', $ancre_link_readmore_menu);
			
			//Params btn close
			$texte_close = $this->params->get('texte_close_'.$langue_code_actif);
			if($texte_close == '') $texte_close = $this->params->get('texte_close_'.$mydefaultlanguage);	
			$btn_close = $this->params->get('btn_close');
			$position_btn_close = $this->params->get('position_btn_close');
			$taille_btn_close = $this->params->get('taille_btn_close');
			$couleur_btn_close = $this->params->get('couleur_btn_close');
			$couleur_texte_btn_close = $this->params->get('couleur_texte_btn_close');

			$application = JFactory::getApplication();
			$menu = $application->getMenu();
			$item = $menu->getItem($link_readmore_menu);

			switch ($type_bordure) {
				//Bordure arrondie
				case '0':
					$css_bordure = "border:".$taille_bordure."px solid ".$couleur_bordure."; border-radius:5px";
					break;
				//Sans bordure
				case '2':
					$css_bordure = "";
					break;
				//Autres
				default:
					$css_bordure = "border: ".$taille_bordure."px solid ".$couleur_bordure.";";
					break;
			}

			//Teste si les deux ou un seul boutons est affichés
			
			$span = $meme_ligne_btn_more = $meme_ligne_btn_close = $meme_ligne = ""; 

			//Position des bouttons à la ligne
			if($position_btn == 0){
				$span= "col-md-6";
				if (($btn_more && !$btn_close) || (!$btn_more && $btn_close)) {
					$span= "col-md-12";
				}
			} 
			//Position des bouttons sur la même ligne que le texte
			elseif($position_btn == 1) {
				$meme_ligne = "pull-left";
			}
			
			$text_btn_more = '<div class="'. $meme_ligne .' '.$span.' btn_readmore" style="text-align:'.$position_btn_more.'"><a style="color:'.$couleur_texte_btn_more.'" class="btn '.$couleur_btn_more.' '.$taille_btn_more.' read_more" href="'.JRoute::_("index.php?Itemid=".$link_readmore_menu).'#'.$ancre_link_readmore_menu.'">'.$texte_readmore.'</a></div>';
			$text_btn_more_poup = '<div class="'.$span.' btn_readmore" style="text-align:'.$position_btn_more.'"><a style="color:'.$couleur_texte_btn_more.'" class="btn '.$couleur_btn_more.' '.$taille_btn_more.' read_more" onclick="jQuery.magnificPopup.close();" href="'.JRoute::_("index.php?Itemid=".$link_readmore_menu).'#'.$ancre_link_readmore_menu.'">'.$texte_readmore.'</a></div>';
			$text_btn_close = '<div class="'.$meme_ligne.' '.$span.' btn_close" style="text-align:'.$position_btn_close.'"><a style="color:'.$couleur_texte_btn_close.'" class="btn '.$couleur_btn_close.' '.$taille_btn_close.' popup-modal-dismiss" href="#">'.$texte_close.'</a></div>';

			$text_out ='<div id="cadre_alert_cookies" style="text-align: '.$position_contenu.';'.$position_fixe_cookie.' margin: '.$marge_ext.'px;">';
			$text_out .='<div style="display: inline-block;width: 100%;margin:auto;max-width:'.$taille_cadre.';background-color: '.$fond_couleur.';'.$css_bordure.'">';
			$text_out .='<div style="display: inline-block;padding:'.$marge_int.'px;color: '.$texte_couleur.'"><div class='.$meme_ligne.'>'.$texte.'</div>';
			$text_out .='<div class="row-fluid '.$meme_ligne.'">';
			
			//Affichage encadré
			if ($type_affichage == 1) {	$text_out_btn_more = $text_btn_more; } 
			//Affichage popup
			elseif($type_affichage == 0) { $text_out_btn_more = $text_btn_more_poup; }			
				
			//Boutton fermer en premier
			if($first_btn == 0) {
				if($btn_close) { $text_out .= $text_btn_close;	}
				if($btn_more) { $text_out .= $text_out_btn_more; }				
			} 
			//Boutton en savoir plus en premier
			elseif($first_btn == 1) {
				if($btn_more) { $text_out .= $text_out_btn_more; }
				if($btn_close) { $text_out .= $text_btn_close;	}		
			}

			$text_out .='</div></div></div></div>';

			//Récupére le code html de la page affichée
			$buffer = JResponse::getBody();

			//Affichage encadré
			if ($type_affichage == 1) {

				$script = '<script type="text/javascript">';
				$script .="jQuery(document).on('click', '.popup-modal-dismiss', function () {jQuery('#cadre_alert_cookies').html(''); document.cookie='fmalertcookies=true';});";
				$script .="</script>";

				// Position Haut
				if ($position == 0) {
                    $buffer = preg_replace('/<body(.*?)>/i', '<body$1>'.$text_out.$script, $buffer);
				}
				// Position Bas
				elseif ($position == 1) {
					$buffer = preg_replace('/<\/body>/i',$text_out.$script.'</body>', $buffer);
				}
			}

			//Affichage Popup
			elseif($type_affichage == 0) {

				$params = "";
				if ($btn_close) {
					$params = "modal: true";
				} else {
					//Insert un cookie pour éviter de réafficher le message.
					setcookie ( 'fmalertcookies',true);
				}

				$popup = '<script type="text/javascript">';
				$popup .="jQuery.magnificPopup.open({items: {src: '". str_replace("\r\n", "",addslashes($text_out))."',type: 'inline'},$params});";
				$popup .="jQuery(document).on('click', '.popup-modal-dismiss', function (e) {e.preventDefault();jQuery.magnificPopup.close(); document.cookie='fmalertcookies=true';});";
				$popup .="</script>";
				$buffer = str_replace('</body>',$popup.'</body>', $buffer);
			}


			JResponse::setBody($buffer);
		}
    }
}

?>